/***************************************************************************
                          dlg_challenge.h  -  description
                             -------------------
    begin                : Sun Jan 20 2002
    copyright            : (C) 2003 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLG_CHALLENGE_H
#define DLG_CHALLENGE_H

#include <kdialogbase.h>
#include <kcombobox.h>
#include <qgroupbox.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qvbox.h>
#include <qhbox.h>
#include "resource.h"

/**
  *@author Troy Corbin Jr.
  */

class dlg_challenge : public KDialogBase
{
  Q_OBJECT
	public:
										dlg_challenge(QWidget *parent=0, const char *name=0, resource *Rsrc=0);
										~dlg_challenge();
		void						setValues( const QString&, const QString& );
		QString					values( void );
	public slots:
		void						slot_changed( int );
		void						slot_timeOdds( bool );
	private:
		resource				*Resource;
		QString					otherPlayer;
		QString					localRating;
		QString					otherRating;

		QVBox						*BOX_Parent;
		QLabel					*LABEL_Headline;
		KComboBox				*COMBO_Rated;
		QHBox						*BOX_Time;
		QGroupBox				*BOX_White;
		QSpinBox				*BOX_WhiteBase;
		QSpinBox				*BOX_WhiteInc;
		QLabel					*LABEL_WhiteBase;
		QLabel					*LABEL_WhiteInc;
		QGroupBox				*BOX_Black;
		QSpinBox				*BOX_BlackBase;
		QSpinBox				*BOX_BlackInc;
		QLabel					*LABEL_BlackBase;
		QLabel					*LABEL_BlackInc;
		QCheckBox				*BUTTON_TimeOdds;
};

#endif
